package be.iminds.ilabt.jfed.git;

import java.io.File;

public class GitFetcherCommandBuilder {
    private String gitUrl;
    private String repoSubDir;
    private String branch;
    private String username;
    private String password;
    private String privateKeyPem;
    private File targetDir;
    private boolean allowCreateDir;
    private boolean overwriteFilesInDir;

    public GitFetcherCommandBuilder() {
    }

    public GitFetcherCommandBuilder(String gitUrl) {
        this.gitUrl = gitUrl;
    }

    public GitFetcherCommandBuilder setGitUrl(String gitUrl) {
        this.gitUrl = gitUrl;
        return this;
    }

    public GitFetcherCommandBuilder setRepoSubDir(String repoSubDir) {
        this.repoSubDir = repoSubDir;
        return this;
    }

    public GitFetcherCommandBuilder setBranch(String branch) {
        this.branch = branch;
        return this;
    }

    public GitFetcherCommandBuilder setUsername(String username) {
        this.username = username;
        return this;
    }

    public GitFetcherCommandBuilder setPassword(String password) {
        this.password = password;
        return this;
    }

    public GitFetcherCommandBuilder setPrivateKeyPem(String privateKeyPem) {
        this.privateKeyPem = privateKeyPem;
        return this;
    }

    public GitFetcherCommandBuilder setTargetDir(File targetDir) {
        this.targetDir = targetDir;
        return this;
    }

    public GitFetcherCommandBuilder setAllowCreateDir(boolean allowCreateDir) {
        this.allowCreateDir = allowCreateDir;
        return this;
    }

    public GitFetcherCommandBuilder setOverwriteFilesInDir(boolean overwriteFilesInDir) {
        this.overwriteFilesInDir = overwriteFilesInDir;
        return this;
    }

    public GitFetcherCommand build() {
        if (gitUrl == null)
            throw new IllegalStateException("gitUrl is a required argument of GitFetchCommand");
        return new GitFetcherCommand(gitUrl, repoSubDir, branch, username, password, privateKeyPem,
                targetDir, allowCreateDir, overwriteFilesInDir);
    }
}